import React from 'react';
import { Mode } from './config';
import { RouteConfig, RenderRoute, SetTabNameFn } from './useSwitchTabs';
import { RoughLocation } from '.';
export declare function isRouteTab(location: RoughLocation, originalRoutes: RouteConfig[]): boolean;
/**
 * 解析路由定义中参数
 *
 * 如： `path = /user/:id` ，`pathname = /user/48` ，可解析得到 `{ id: "48" }`
 *
 * @param path 路由定义
 * @param pathname 当前的页面路由
 */
export declare function getParams(path: string, pathname: string): {
    [key: string]: string;
};
/**
 * 获取要激活的标签页信息
 *
 * @param options 其中，`location` 必须是 `react-router` 注入的 `location`，否则部署到非根目录功能时功能异常
 * @returns
 */
export declare function getRenderRoute(options: {
    location: RoughLocation;
    mode: Mode;
    originalRoutes: RouteConfig[];
    setTabName?: SetTabNameFn;
}): RenderRoute;
export declare const routePagePropsAreEqual: (prevProps: any, nextProps: any) => boolean;
export declare function withSwitchTab<Props = unknown>(WrappedComponent: React.ComponentType<Props>): React.MemoExoticComponent<any>;
export declare function getRenderRouteKey(renderRoute: RenderRoute, mode: Mode): string;
